ORIGPWD="$PWD"
cd "$MUSL_CC_BASE"
MUSL_CC_BASE="$PWD"
export MUSL_CC_BASE
cd "$ORIGPWD"
unset ORIGPWD

if [ ! -e config.sh ]
then
    echo 'Create a config.sh file.'
    exit 1
fi

# ADACORE GPL 2015
GCC_INTERFACE_URL=http://mirrors.cdn.adacore.com/art/564b3e2ec8e196b040fbd137
GCC_URL=http://mirrors.cdn.adacore.com/art/564b3e2ec8e196b040fbd141
GNAT_GPL_URL=http://mirrors.cdn.adacore.com/art/564b3e2ec8e196b040fbd13c


die() {
    echo "$@"
    exit 1
}

fetch() {
    if [ ! -e "$MUSL_CC_BASE/tarballs/$2" ]
    then
        wget -O "$MUSL_CC_BASE/tarballs/$2.part" -c "$1"
        mv "$MUSL_CC_BASE/tarballs/$2.part" "$MUSL_CC_BASE/tarballs/$2"
    fi
    return 0
}

extract() {
    if [ ! -e "$2/extracted" ]
    then
        tar xf "$MUSL_CC_BASE/tarballs/$1" ||
            tar Jxf "$MUSL_CC_BASE/tarballs/$1" ||
            tar jxf "$MUSL_CC_BASE/tarballs/$1" ||
            tar zxf "$MUSL_CC_BASE/tarballs/$1"
        mkdir -p "$2"
        touch "$2/extracted"
    fi
}

stripfileext() {
	case "$1" in
		*.tar.*) printf "%s" "$1"| sed 's/\.tar\.[0-9a-z]*$//' ;;
		*) basename "$1" | sed 's/\..*//' ;;
	esac
}

fetchextract() {
    baseurl="$1"
    dir="$2"
    fn="$2""$3"

    fetch "$baseurl" "$fn"
    extract "$fn" "$dir"
}


download_adacore() {
    fetchextract $GCC_INTERFACE_URL  gcc-interface-4.9-gpl-2015-src .tar.gz
    fetchextract $GCC_URL  gcc-4.9-gpl-2015-src .tar.gz 
    fetchextract $GNAT_GPL_URL gnat-gpl-2015-src .tar.gz 
}

merge_and_create_tar() {
	# we make the adacore gpl a fake gcc-4.9.adacore2015 FSF gcc
	# we then put this gcc-4.9.adacore2015 where the rest of the machinery
	# expects it and do the build as it was
	cp -R gcc-4.9-gpl-2015-src/ gcc-4.9.adacore2015
	cp -R gnat-gpl-2015-src/src/ada gcc-4.9.adacore2015/gcc/
	cp -R gcc-interface-4.9-gpl-2015-src gcc-4.9.adacore2015/gcc/ada/gcc-interface
	tar -cf "$MUSL_CC_BASE/tarballs/gcc-4.9.adacore2015.tar" gcc-4.9.adacore2015	
	bzip2 "$MUSL_CC_BASE/tarballs/gcc-4.9.adacore2015.tar"
}

download_adacore
merge_and_create_tar
